<?php
require_once( 'ical/iCalcreator.class.php' );



//var_dump($flights);

$fp = fopen("airports.dat", "r");

$row = 0;
while ($line = fgetcsv($fp))
{
	$airports[$row] = $line;
	if ($line[4] == "PHX")
	{
		$myoffset = $line[9];
		$mydst = $line[10];
	}
	$row++;
}
fclose($fp);

function getAirportOffset($name, $date_time)
{
	global	$airports;
	global	$myoffset;
	global	$mydst;
	foreach($airports as $ap)
	{
		if ($ap[4] == $name)
		{
			if ($ap[10] != $mydst)
			{
				$dt = $date_time;
				$dt->setTimezone(new DateTimeZone("America/New_York"));
				if ($dt->format('I') == 1)
				{
					$dt->setTimezone(new DateTimeZone("America/Phoenix"));
//					var_dump($dt);
					return $myoffset - $ap[9] - 1;
				}
				$dt->setTimezone(new DateTimeZone("America/Phoenix"));
			}
			return $myoffset - $ap[9];
		}
	}
}
//var_dump($airports);


$config = array( 'unique_id' => 'clingman.org' );
  // set Your unique id
$v = new vcalendar( $config );
  // create a new calendar instance

$v->setProperty( 'method', 'PUBLISH' );
  // required of some calendar software
$v->setProperty( "x-wr-calname", "Flight Calendar" );
  // required of some calendar software
$v->setProperty( "X-WR-CALDESC", "My Southwest.com flights" );
  // required of some calendar software
$v->setProperty( "X-WR-TIMEZONE", "America/Phoenix" );

$fp = fopen("/tmp/find_air_receipt.csv", "r");

$row = 0;
while ($flight = fgetcsv($fp))
{
	// Confirm, flight, date, depart, arrive

	$year = substr($flight[3], 0, 4);

	if (is_numeric($year) && strlen($year) > 0)
	{
		if (preg_match("/\((.*)\).at.(.*)$/", $flight[4], $matches))
		{
			$from = $matches[1];
			$from_time = $matches[2];

			$from_time = new DateTime($flight[3] . " " . $from_time, new DateTimeZone("America/Phoenix"));
			$from_time->add(DateInterval::createFromDateString(getAirportOffset($from, $from_time) . " hours"));
		}

		if (preg_match("/\((.*)\).at.(.*)$/", $flight[5], $matches))
		{
			$to = $matches[1];
			$to_time = $matches[2];
			$to_time = new DateTime($flight[3] . " " . $to_time, new DateTimeZone("America/Phoenix"));
			$to_time->add(DateInterval::createFromDateString(getAirportOffset($to, $to_time) . " hours"));

			if ($to_time->getTimestamp() < $from_time->getTimestamp())
			{
				$to_time->add(DateInterval::createFromDateString("1 day"));
			}
			// make from and to time pallettable to iCal class...
			$from_time = date_parse($from_time->format(DateTime::ATOM));

			unset($from_time['fraction']);
			unset($from_time['warning_count']);
			unset($from_time['warnings']);
			unset($from_time['error_count']);
			unset($from_time['errors']);
			unset($from_time['is_localtime']);
			unset($from_time['zone']);
			unset($from_time['is_dst']);
			$from_time['min'] = $from_time['minute'];
			unset($from_time['minute']);

			$to_time = date_parse($to_time->format(DateTime::ATOM));

			unset($to_time['fraction']);
			unset($to_time['warning_count']);
			unset($to_time['warnings']);
			unset($to_time['error_count']);
			unset($to_time['errors']);
			unset($to_time['is_localtime']);
			unset($to_time['zone']);
			unset($to_time['is_dst']);

			$to_time['min'] = $to_time['minute'];
			unset($to_time['minute']);

			$event = & $v->newComponent('vevent');
			$event->setProperty('dtstart', $from_time);
			$event->setProperty('dtend', $to_time);

			$event->setProperty('location', $from);
			$event->setProperty('summary', 'Flight ' . $flight[2] . " From:" . $from . " To:" . $to . " Conf: " . $flight[0] . " Passenger: " . $flight[1]);
		}
	}
}
fclose($fp);

$v->returnCalendar();

?>
